;---------------------------------------------------------------------------------
;Inizializza il modulo scelto
; Input:  FlagsRx
; Output: ModStat
; Usate:  CTimeout, Count1

init_module
        btfss   F_MODTYPE
        goto    init_module_mdfly

;Inizializzazione modulo VS1000
; - Attesa stringa 'SD' (presenza memoria SD)
; - Attesa stringa 'play' (partenza primo file in modalit play continuo)
; - Inoltro comandi modalit file e stop
; - Attesa stringa 'done'

init_module_vs1000
        movlw   TIMEOUT                  ;Inizializza contatore Timeout
        movwf   CTimeout
        movlw   0x03                     ;3 stringhe da ricevere
        movwf   Count1

imv_1   btfss   F_RX_SD                  ;Verifica se sicevuta stringa 'presenza SD'
        goto    imv_2
        bcf     F_RX_SD
        decf    Count1,f

imv_2   btfss   F_RX_PLAY                ;Verifica se sicevuta stringa 'play'
        goto    imv_3                    ;Invia comandi modalit_file e stop
        bcf     F_RX_PLAY
        decf    Count1,f
        call    send_cmd_mfile_stop

imv_3   btfss   F_RX_STOP                ;Verifica se ricevuta stringa 'stop'
        goto    imv_4
        bcf     F_RX_STOP
        decf    Count1,f

imv_4   movf    Count1,w                 ;Ricevute 3 stringhe dal modulo?
        btfss   STATUS,Z
        goto    imv_5
        goto    im_ok                    ;Si, esce con stato modulo 1 (ok)
imv_5   decfsz  CTimeout,f               ;No, decrementa timeout
        goto    imv_6
        goto    im_er                    ;Se timeout=0 esce con stato modulo 5 (errore)

imv_6   call    delay_100ms              ;Ritardo 100ms
        call    drive_hb_led             ;Inverte led heartbeat
        goto    imv_1


;Inizializzazione modulo MDFLY
; - Inoltro comando 0xA2 (richiesta numero file su SD)
; - Attesa risposta numero file (3 tentativi al massimo)

init_module_mdfly
        movlw   0x03                     ;3 tentativi per attesa risposta
        movwf   Count1
imm_1   movlw   TIMEOUT                  ;Inizializza contatore Timeout
        movwf   CTimeout

        movlw   0xA2                     ;Inoltra comando richiesta numero file
        call    tx_char
imm_2   call    delay_100ms              ;Attesa 100ms
        call    drive_hb_led             ;Inverte led heartbeat
        movf    ChrRx,w                  ;Numero file diverso da zero?
        btfsc   STATUS,Z
        goto    imm_3
        clrf    FlagsRx                  ;Si, esce con stato modulo 1 (ok)
        goto    im_ok

imm_3   decfsz  CTimeout,f               ;No, decrementa Timeout
        goto    imm_2
        decfsz  Count1,f                 ;Decrementa contatore tentativi
        goto    imm_1                    ;Se =0 esce con stato modulo 5 (errore)


im_er   movlw   0x05                     ;Uscita inizializzazione con stato 5 (errore)
        movwf   ModStat
;        movlw   'E'
;        call    tx_char
        return

im_ok   movlw   0x01                     ;Uscita inizializzazione con stato 1 (ok)
        movwf   ModStat
;        movlw   'K'
;        call    tx_char
        return


;---------------------------------------------------------------------------------
;Invia al modulo VS1000 i comandi modalit File e Cancel
;Invia al modulo MDFLY il comando Stop

send_cmd_mfile_stop
        movlw   'f'             ;Comando f per Modalit File
        call    tx_char
send_cmd_stop
        movlw   'C'             ;Comando C per Cancel (modulo VS1000)
        btfss   F_MODTYPE
        movlw   0xEF            ;Comando Stop (modulo MDFLY)
        call    tx_char
        return


;---------------------------------------------------------------------------------
;Invia al modulo il comando Play secondo il modulo selezionato:
; - VS1000: Pxx______OGG Cr
; - MDFLY : carattere corrispondente al numero hex del file  (File 28 --> Ascii 40)

; Input:  DigD_H, DigD_L, I_MODTYPE
; Output: ChrTrk
; Usate:  TempM

send_cmd_play
        btfss   I_MODTYPE       ;Verifica modulo selezionato
        goto    send_cmd_play_mdfly

send_cmd_play_vs1000
        movlw   'P'             ;Stampa P
        call    tx_char
        movf    DigD_H,w        ;Numero traccia (01..30)
        addlw   '0'
        call    tx_char
        movf    DigD_L,w
        addlw   '0'
        call    tx_char
        movlw   ' '             ;6 spazi
        call    tx_char
        call    tx_char
        call    tx_char
        call    tx_char
        call    tx_char
        call    tx_char
        movlw   'O'             ;Estensione .OGG
        call    tx_char
        movlw   'G'
        call    tx_char
        call    tx_char
        movlw   D'10'           ;Terminatore Cr
        call    tx_char
        return

send_cmd_play_mdfly
        swapf   DigD_H,w        ;Compone il carattere corrispondente
        iorwf   DigD_L,w        ;all'esadecimale numero file e lo copia
        movwf   ChrTrk          ;su variabile per confronto in irq_rx
        call    tx_char
        return


;---------------------------------------------------------------------------------
;Invia i byte desiderati sulla catena degli shift-register
; Input:  SrData1, SrData2
; Output: O_SRDATA, O_SRCLOCK, O_SRSTROBE
; Usate:  CSrByte, CSrBit

send_shift_register
        bcf     O_SR_DATA                ;Inizializza uscite e variabili
        bcf     O_SR_CLK
        bcf     O_SR_STRB
        clrf    CSrByte

ssr_1   movlw   0x08                     ;Individua byte da inviare
        movwf   CSrBit
        movlw   SrData1+0x00
        addwf   CSrByte,w
        movwf   FSR
ssr_2   btfss   INDF,0                   ;Setta/Resetta linea Data
        goto    ssr_3
        bsf     O_SR_DATA
        goto    ssr_4
ssr_3   bcf     O_SR_DATA
ssr_4   call    delay_1us
        bsf     O_SR_CLK                 ;Genera impulso di Clock
        call    delay_1us
        bcf     O_SR_CLK
        rrf     INDF,f                   ;Ruota byte per prossimo bit da inviare
        decfsz  CSrBit,f                 ;Decrementa contatore bit
        goto    ssr_2
        incf    CSrByte,f                ;Incrementa contatore byte
        movf    CSrByte,w
        xorlw   0x02
        btfss   STATUS,Z
        goto    ssr_1
        bsf     O_SR_STRB                ;Genera impulso Strobe
        call    delay_1us
        bcf     O_SR_STRB
        return
